<?php
/**
 * @package n3t Hidden Captcha
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2018 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Factory;

class plgCaptchaN3tHiddenCaptcha extends CMSPlugin
{

  protected $autoloadLanguage = true;

  public function onDisplay($name, $id, $class)
  {
    $doc = Factory::getDocument();
    $doc->addScriptDeclaration(';
      document.addEventListener("DOMContentLoaded", function() {
        var input = document.getElementById("' . $id .'"),
          span = input.parentNode;
          span.style.position = "relative";
          span.style.overflow = "hidden";
          span.style.width = "0";
          span.style.display = "inline-block";
          input.style.position = "absolute";
          input.style.left = "10px";
      });
    ');
    return '<input type="text" disabled value="' . JText::_('PLG_CAPTCHA_N3THIDDENCAPTCHA_DESCRIPTION') . '" class="n3tHiddenCaptchaDescription" /><span><input type="email" name="' . $name . '" id="' . $id . '" tabindex="-1"/></span>';
  }

  public function onCheckAnswer($code)
  {
    if (empty($code))
      return true;

    $this->_subject->setError(JText::_('PLG_CAPTCHA_N3THIDDENCAPTCHA_WRONG_ANSWER'));
    return false;
  }

}